﻿using System;

namespace MyDLR
{
    /// <summary>
    /// Interface to implement in each dynamic language.
    /// </summary>
    public interface IDLRProvider
    {
        /// <summary>
        /// Test is the language contain a definition for a class.
        /// </summary>
        /// <param name="classname">class name</param>
        /// <returns>true if language contain has this class</returns>
        bool HasClass(string classname);

        /// <summary>
        /// Create an instance of the class using parameters values.
        /// </summary>
        /// <param name="classname">class name</param>
        /// <param name="args">arguments for constructor</param>
        /// <returns>the newly created object</returns>
        object CreateInstance(string classname, params object[] args);
    }
}
