﻿using MyJScript;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace MyDLRUnitTest
{
    /// <summary>
    ///This is a test class for MJSFunctionTest and is intended
    ///to contain all MJSFunctionTest Unit Tests
    ///</summary>
    [TestClass()]
    public class MJSFunctionTest
    {
        MJSObject hello(MJSObject @this, params MJSObject[] args)
        {
            return new MJSString("Hello!");
        }

        MJSObject setemployee(MJSObject @this, params MJSObject[] args)
        {
            @this.Set("name", args[0]);
            @this.Set("age", args[1]);

            return null;
        }

        MJSObject getname(MJSObject @this, params MJSObject[] args)
        {
            return @this.Get("name");
        }

        /// <summary>
        ///A test for MJSFunction Constructor
        ///</summary>
        [TestMethod()]
        public void MJSFunctionConstructorTest()
        {
            MJSFunction f1 = new MJSFunction(null);
            Assert.AreEqual("function() {}", f1.ToString());

            MJSFunction f2 = new MJSFunction(hello);
            Assert.AreEqual("function() {}", f2.ToString());
        }

        /// <summary>
        ///A test for Call
        ///</summary>
        [TestMethod()]
        public void CallTest()
        {
            MJSFunction f1 = new MJSFunction(null);
            Assert.AreEqual("function() {}", f1.ToString());
            Assert.IsNull(f1.Call(null));

            MJSFunction f2 = new MJSFunction(hello);
            Assert.AreEqual("function() {}", f2.ToString());
            Assert.AreEqual("\"Hello!\"", f2.Call(null).ToString());

            MJSFunction f3 = new MJSFunction(setemployee);
            Assert.AreEqual("function() {}", f3.ToString());
            MJSObject o1 = new MJSObject();
            Assert.IsNull(f3.Call(o1, new MJSString("Lionel"), new MJSNumber(37)));
            Assert.AreEqual("{\"name\":\"Lionel\", \"age\":37}", o1.ToString());

            MJSFunction f4 = new MJSFunction(getname);
            Assert.AreEqual("function() {}", f4.ToString());
            Assert.AreEqual("\"Lionel\"", f4.Call(o1).ToString());
        }
    }
}
