﻿using MyJScript;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace MyDLRUnitTest
{
    /// <summary>
    ///This is a test class for MJSObjectTest and is intended
    ///to contain all MJSObjectTest Unit Tests
    ///</summary>
    [TestClass()]
    public class MJSObjectTest
    {
        /// <summary>
        ///A test for Set
        ///</summary>
        [TestMethod()]
        public void SetTest()
        {
            MJSObject o1 = new MJSObject();
            Assert.AreEqual("{}", o1.ToString());

            o1.Set("name", new MJSString("Hello"));
            Assert.AreEqual("{\"name\":\"Hello\"}", o1.ToString());
            o1.Set("age", new MJSNumber(37));
            Assert.AreEqual("{\"name\":\"Hello\", \"age\":37}", o1.ToString());
            o1.Set("tostring", new MJSFunction(null));
            Assert.AreEqual("{\"name\":\"Hello\", \"age\":37, \"tostring\":function() {}}", o1.ToString());
            o1.Set("age", new MJSNumber(43));
            Assert.AreEqual("{\"name\":\"Hello\", \"age\":43, \"tostring\":function() {}}", o1.ToString());

            MJSObject o2 = new MJSObject();
            o2.Set("x", new MJSNumber(1));
            o2.Set("y", new MJSNumber(2));
            Assert.AreEqual("{\"x\":1, \"y\":2}", o2.ToString());

            o1.Set("point", o2);
            Assert.AreEqual("{\"name\":\"Hello\", \"age\":43, \"tostring\":function() {}, \"point\":{\"x\":1, \"y\":2}}", o1.ToString());
        }

        /// <summary>
        ///A test for Get
        ///</summary>
        [TestMethod()]
        public void GetTest()
        {
            MJSObject o1 = new MJSObject();
            Assert.IsNull(o1.Get("name"));

            o1.Set("name", new MJSString("Hello"));
            Assert.AreEqual("\"Hello\"", o1.Get("name").ToString());
            o1.Set("age", new MJSNumber(37));
            Assert.AreEqual("\"Hello\"", o1.Get("name").ToString());
            Assert.AreEqual("37", o1.Get("age").ToString());
            o1.Set("tostring", new MJSFunction(null));
            Assert.AreEqual("\"Hello\"", o1.Get("name").ToString());
            Assert.AreEqual("37", o1.Get("age").ToString());
            Assert.AreEqual("function() {}", o1.Get("tostring").ToString());

            o1.Set("age", new MJSNumber(43));
            Assert.AreEqual("\"Hello\"", o1.Get("name").ToString());
            Assert.AreEqual("43", o1.Get("age").ToString());
            Assert.AreEqual("function() {}", o1.Get("tostring").ToString());

            MJSObject o2 = new MJSObject();
            o2.Set("x", new MJSNumber(1));
            o2.Set("y", new MJSNumber(2));
            Assert.AreEqual("1", o2.Get("x").ToString());
            Assert.AreEqual("2", o2.Get("y").ToString());

            o1.Set("point", o2);
            Assert.AreEqual("\"Hello\"", o1.Get("name").ToString());
            Assert.AreEqual("43", o1.Get("age").ToString());
            Assert.AreEqual("function() {}", o1.Get("tostring").ToString());
            Assert.AreEqual("{\"x\":1, \"y\":2}", o1.Get("point").ToString());
        }
    }
}
